------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Abstract_Scroll_Areas;
limited with Qt4.Menus;
with Qt4.Points;
with Qt4.Rects;
with Qt4.Strings;
with Qt4.Text_Char_Formats;
with Qt4.Text_Cursors;
limited with Qt4.Text_Documents;
with Qt4.Text_Options;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Plain_Text_Edits is

   type Plain_Text_Edit_Line_Wrap_Mode is
    (No_Wrap,
     Widget_Width);
   pragma Convention (C, Plain_Text_Edit_Line_Wrap_Mode);

   type Q_Plain_Text_Edit is limited interface
     and Qt4.Abstract_Scroll_Areas.Q_Abstract_Scroll_Area;

   type Q_Plain_Text_Edit_Access is
     access all Q_Plain_Text_Edit'Class;
   for Q_Plain_Text_Edit_Access'Storage_Size use 0;

   type Q_Plain_Text_Edit_Pointer is tagged;

   function Background_Visible
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Standard.Boolean;

   function Block_Count
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Standard.Boolean;

   function Can_Paste
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Standard.Boolean;

   function Center_On_Scroll
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Standard.Boolean;

   function Create_Standard_Context_Menu
    (Self : not null access Q_Plain_Text_Edit'Class)
       return not null access Qt4.Menus.Q_Menu'Class;

   function Current_Char_Format
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Qt4.Text_Char_Formats.Q_Text_Char_Format;

   function Cursor_For_Position
    (Self : not null access constant Q_Plain_Text_Edit'Class;
     Pos : Qt4.Points.Q_Point)
       return Qt4.Text_Cursors.Q_Text_Cursor;

   function Cursor_Rect
    (Self : not null access constant Q_Plain_Text_Edit'Class;
     Cursor : Qt4.Text_Cursors.Q_Text_Cursor)
       return Qt4.Rects.Q_Rect;

   function Cursor_Rect
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Qt4.Rects.Q_Rect;

   function Cursor_Width
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Qt4.Q_Integer;

   function Document
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return not null access Qt4.Text_Documents.Q_Text_Document'Class;

   function Document_Title
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Qt4.Strings.Q_String;

   procedure Ensure_Cursor_Visible
    (Self : not null access Q_Plain_Text_Edit'Class);

   function Is_Read_Only
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Standard.Boolean;

   function Is_Undo_Redo_Enabled
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Standard.Boolean;

   function Line_Wrap_Mode
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Qt4.Plain_Text_Edits.Plain_Text_Edit_Line_Wrap_Mode;

   function Maximum_Block_Count
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Qt4.Q_Integer;

   procedure Merge_Current_Char_Format
    (Self : not null access Q_Plain_Text_Edit'Class;
     Modifier : Qt4.Text_Char_Formats.Q_Text_Char_Format'Class);

   function Overwrite_Mode
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Standard.Boolean;

   procedure Set_Background_Visible
    (Self : not null access Q_Plain_Text_Edit'Class;
     Visible : Standard.Boolean);

   procedure Set_Center_On_Scroll
    (Self : not null access Q_Plain_Text_Edit'Class;
     Enabled : Standard.Boolean);

   procedure Set_Current_Char_Format
    (Self : not null access Q_Plain_Text_Edit'Class;
     Modifier : Qt4.Text_Char_Formats.Q_Text_Char_Format'Class);

   procedure Set_Cursor_Width
    (Self : not null access Q_Plain_Text_Edit'Class;
     Width : Qt4.Q_Integer);

   procedure Set_Document
    (Self : not null access Q_Plain_Text_Edit'Class;
     Document : not null access Qt4.Text_Documents.Q_Text_Document'Class);

   procedure Set_Document_Title
    (Self : not null access Q_Plain_Text_Edit'Class;
     Title : Qt4.Strings.Q_String);

   procedure Set_Line_Wrap_Mode
    (Self : not null access Q_Plain_Text_Edit'Class;
     Mode : Qt4.Plain_Text_Edits.Plain_Text_Edit_Line_Wrap_Mode);

   procedure Set_Maximum_Block_Count
    (Self : not null access Q_Plain_Text_Edit'Class;
     Maximum : Qt4.Q_Integer);

   procedure Set_Overwrite_Mode
    (Self : not null access Q_Plain_Text_Edit'Class;
     Overwrite : Standard.Boolean);

   procedure Set_Read_Only
    (Self : not null access Q_Plain_Text_Edit'Class;
     Ro : Standard.Boolean);

   procedure Set_Tab_Changes_Focus
    (Self : not null access Q_Plain_Text_Edit'Class;
     B : Standard.Boolean);

   procedure Set_Tab_Stop_Width
    (Self : not null access Q_Plain_Text_Edit'Class;
     Width : Qt4.Q_Integer);

   procedure Set_Text_Cursor
    (Self : not null access Q_Plain_Text_Edit'Class;
     Cursor : Qt4.Text_Cursors.Q_Text_Cursor);

   procedure Set_Undo_Redo_Enabled
    (Self : not null access Q_Plain_Text_Edit'Class;
     Enable : Standard.Boolean);

   function Tab_Changes_Focus
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Standard.Boolean;

   function Tab_Stop_Width
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Qt4.Q_Integer;

   function Text_Cursor
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Qt4.Text_Cursors.Q_Text_Cursor;

   function To_Plain_Text
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Qt4.Strings.Q_String;

   function Word_Wrap_Mode
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Qt4.Text_Options.Text_Option_Wrap_Mode;

   procedure Append_Html
    (Self : not null access Q_Plain_Text_Edit'Class;
     Html : Qt4.Strings.Q_String);

   procedure Append_Plain_Text
    (Self : not null access Q_Plain_Text_Edit'Class;
     Text : Qt4.Strings.Q_String);

   procedure Center_Cursor
    (Self : not null access Q_Plain_Text_Edit'Class);

   procedure Clear
    (Self : not null access Q_Plain_Text_Edit'Class);

   procedure Copy
    (Self : not null access Q_Plain_Text_Edit'Class);

   procedure Cut
    (Self : not null access Q_Plain_Text_Edit'Class);

   procedure Insert_Plain_Text
    (Self : not null access Q_Plain_Text_Edit'Class;
     Text : Qt4.Strings.Q_String);

   procedure Paste
    (Self : not null access Q_Plain_Text_Edit'Class);

   procedure Redo
    (Self : not null access Q_Plain_Text_Edit'Class);

   procedure Select_All
    (Self : not null access Q_Plain_Text_Edit'Class);

   procedure Set_Plain_Text
    (Self : not null access Q_Plain_Text_Edit'Class;
     Text : Qt4.Strings.Q_String);

   procedure Undo
    (Self : not null access Q_Plain_Text_Edit'Class);

   procedure Move_Cursor
    (Self      : not null access Q_Plain_Text_Edit'Class;
     Operation : Qt4.Text_Cursors.Move_Operation;
     Mode      : Qt4.Text_Cursors.Move_Mode := Qt4.Text_Cursors.Move_Anchor);

   package Q_Plain_Text_Edit_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Plain_Text_Edit, Q_Plain_Text_Edit_Access);

   type Q_Plain_Text_Edit_Pointer is
     new Q_Plain_Text_Edit_Pointers.Q_Pointer with null record;

end Qt4.Plain_Text_Edits;
